/*
 * Copyright (c) 2010-2011, The MiCode Open Source Community (www.micode.net)
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *        http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

package net.micode.notes.widget;
import android.app.PendingIntent;
import android.appwidget.AppWidgetManager;
import android.appwidget.AppWidgetProvider;
import android.content.ContentValues;
import android.content.Context;
import android.content.Intent;
import android.database.Cursor;
import android.util.Log;
import android.widget.RemoteViews;

import net.micode.notes.R;
import net.micode.notes.data.Notes;
import net.micode.notes.data.Notes.NoteColumns;
import net.micode.notes.tool.ResourceParser;
import net.micode.notes.ui.NoteEditActivity;
import net.micode.notes.ui.NotesListActivity;

// 这是一个抽象类，用于提供笔记小部件的功能
public abstract class NoteWidgetProvider extends AppWidgetProvider {
    // 定义查询数据库时需要获取的列
    public static final String [] PROJECTION = new String [] {
            NoteColumns.ID, // 笔记ID
            NoteColumns.BG_COLOR_ID, // 笔记背景颜色ID
            NoteColumns.SNIPPET // 笔记摘要
    };

    // 定义列索引常量，方便后续通过索引获取数据
    public static final int COLUMN_ID           = 0;
    public static final int COLUMN_BG_COLOR_ID  = 1;
    public static final int COLUMN_SNIPPET      = 2;

    // 定义日志标签
    private static final String TAG = "NoteWidgetProvider";

    // 当小部件被删除时调用此方法
    @Override
    public void onDeleted(Context context, int[] appWidgetIds) {
        // 创建一个ContentValues对象，用于更新数据库中的数据
        ContentValues values = new ContentValues();
        // 将小部件ID设置为无效ID
        values.put(NoteColumns.WIDGET_ID, AppWidgetManager.INVALID_APPWIDGET_ID);
        // 遍历所有被删除的小部件ID，并更新数据库中对应的数据
        for (int i = 0; i < appWidgetIds.length; i++) {
            context.getContentResolver().update(Notes.CONTENT_NOTE_URI,
                    values,
                    NoteColumns.WIDGET_ID + "=?",
                    new String[] { String.valueOf(appWidgetIds[i])});
        }
    }

    // 私有方法，用于获取指定小部件ID的笔记信息
    private Cursor getNoteWidgetInfo(Context context, int widgetId) {
        // 查询数据库，获取指定小部件ID且不在垃圾箱中的笔记信息
        return context.getContentResolver().query(Notes.CONTENT_NOTE_URI,
                PROJECTION,
                NoteColumns.WIDGET_ID + "=? AND " + NoteColumns.PARENT_ID + "<>?",
                new String[] { String.valueOf(widgetId), String.valueOf(Notes.ID_TRASH_FOLER) },
                null);
    }

    // 保护方法，用于更新小部件，不开启隐私模式
    protected void update(Context context, AppWidgetManager appWidgetManager, int[] appWidgetIds) {
        update(context, appWidgetManager, appWidgetIds, false);
    }

    // 私有方法，用于更新小部件，可选择是否开启隐私模式
    private void update(Context context, AppWidgetManager appWidgetManager, int[] appWidgetIds,
                        boolean privacyMode) {
        // 遍历所有需要更新的小部件ID
        for (int i = 0; i < appWidgetIds.length; i++) {
            // 如果小部件ID有效
            if (appWidgetIds[i] != AppWidgetManager.INVALID_APPWIDGET_ID) {
                // 初始化背景颜色ID和摘要
                int bgId = ResourceParser.getDefaultBgId(context);
                String snippet = "";
                // 创建一个指向NoteEditActivity的Intent，用于点击小部件时跳转
                Intent intent = new Intent(context, NoteEditActivity.class);
                intent.setFlags(Intent.FLAG_ACTIVITY_SINGLE_TOP);
                intent.putExtra(Notes.INTENT_EXTRA_WIDGET_ID, appWidgetIds[i]);
                intent.putExtra(Notes.INTENT_EXTRA_WIDGET_TYPE, getWidgetType());

                // 获取指定小部件ID的笔记信息
                Cursor c = getNoteWidgetInfo(context, appWidgetIds[i]);
                // 如果获取到笔记信息
                if (c != null && c.moveToFirst()) {
                    // 如果有多条笔记信息使用相同的小部件ID，记录错误日志并返回
                    if (c.getCount() > 1) {
                        Log.e(TAG, "Multiple message with same widget id:" + appWidgetIds[i]);
                        c.close();
                        return;
                    }
                    // 获取摘要和背景颜色ID，并设置到Intent中
                    snippet = c.getString(COLUMN_SNIPPET);
                    bgId = c.getInt(COLUMN_BG_COLOR_ID);
                    intent.putExtra(Intent.EXTRA_UID, c.getLong(COLUMN_ID));
                    intent.setAction(Intent.ACTION_VIEW);
                } else {
                    // 如果没有获取到笔记信息，设置默认摘要，并设置Intent动作为插入或编辑
                    snippet = context.getResources().getString(R.string.widget_havenot_content);
                    intent.setAction(Intent.ACTION_INSERT_OR_EDIT);
                }

                // 关闭Cursor
                if (c != null) {
                    c.close();
                }

                // 创建一个RemoteViews对象，用于设置小部件的UI
                RemoteViews rv = new RemoteViews(context.getPackageName(), getLayoutId());
                // 设置背景图片
                rv.setImageViewResource(R.id.widget_bg_image, getBgResourceId(bgId));
                // 将背景颜色ID设置到Intent中
                intent.putExtra(Notes.INTENT_EXTRA_BACKGROUND_ID, bgId);

                // 根据是否开启隐私模式，设置不同的文本和点击行为
                PendingIntent pendingIntent = null;
                if (privacyMode) {
                    rv.setTextViewText(R.id.widget_text,
                            context.getString(R.string.widget_under_visit_mode));
                    pendingIntent = PendingIntent.getActivity(context, appWidgetIds[i], new Intent(
                            context, NotesListActivity.class), PendingIntent.FLAG_UPDATE_CURRENT);
                } else {
                    rv.setTextViewText(R.id.widget_text, snippet);
                    pendingIntent = PendingIntent.getActivity(context, appWidgetIds[i], intent,
                            PendingIntent.FLAG_UPDATE_CURRENT);
                }

                // 设置小部件的点击行为
                rv.setOnClickPendingIntent(R.id.widget_text, pendingIntent);
                // 更新小部件的UI
                appWidgetManager.updateAppWidget(appWidgetIds[i], rv);
            }
        }
    }

    // 抽象方法，由子类实现，用于获取背景资源ID
    protected abstract int getBgResourceId(int bgId);

    // 抽象方法，由子类实现，用于获取布局ID
    protected abstract int getLayoutId();

    // 抽象方法，由子类实现，用于获取小部件类型
    protected abstract int getWidgetType();
}
